package com.sds.portal.file.command;

import com.oreilly.servlet.ParameterParser;

import java.util.*;
import java.io.*;
import javax.servlet.http.*;
import javax.servlet.*;
import javax.naming.*;
import javax.transaction.*;

import com.sds.common.command.*;
import com.sds.portal.file.delegate.FileDelegate;
import com.sds.portal.file.vo.*;
import com.sds.portal.file.command.*;
import com.sds.common.util.*;

public class DeleteFileCmd extends Command {
    private String forwardPage;

    /**
     * @supplierCardinality 1
     * @clientCardinality 1 
     */
    private FileDelegate fileDelegate;

    public String execute(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Context ctx = null;
        Locator locator = Locator.getInstance();

		// parameter data
		Integer fileId = null;
		String repositoryPath = null;
		String aliasFileName = null;
		String originalFileName = null;

		InputStream inputStream = null;
		OutputStream outputStream = null;

		// determin interface type
        Boolean isLocalInteface = (Boolean) locator.lookup("java:comp/env/file/isLocalInterface");

		// delegate
		fileDelegate = new FileDelegate(isLocalInteface);

		try {
            // request parser
            ParameterParser parser = new ParameterParser(req);
            
            // execute bisiness logic
            fileId = new Integer(parser.getIntParameter("fileId"));

            FileVo fileVo = fileDelegate.getFileVo(fileId);
            repositoryPath = fileVo.getRepositoryPath();
            aliasFileName = fileVo.getAliasFileName();

            if (fileId == null) throw new Exception();
            if (repositoryPath == null) throw new Exception();
            if (aliasFileName == null) throw new Exception();

            // delete file on filesystem
            File file = new File(repositoryPath + aliasFileName);
            file.delete();

            // execute adapter
            try {
				String[] adapteeClassNames = (String[]) locator.lookup("java:comp/env/file/deleteFileCmdAdapteeClassNames", ",");
				Adapter adapter = new Adapter(req, res);
				adapter.executeAdapter(adapteeClassNames);
            } catch (NameNotFoundException ex) {
            } catch (Exception ex) {
                throw new Exception();
            }

            // delete file info on database
            fileDelegate.delete(fileId);
            return this.getForwardPage();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (inputStream != null) inputStream.close();
            if (outputStream != null) outputStream.close();
        }
    }

    public DeleteFileCmd(String forwardPage) {
        super(forwardPage);
    }
    public DeleteFileCmd() {
        super();
    }
}
