/* Generated by Together */

package com.sds.portal.file.dao;

import java.sql.*;
import javax.sql.*;
import java.util.*;

import com.sds.common.dao.Dao;
import com.sds.portal.file.vo.*;

public class FileMapDao extends Dao {
    private static boolean initFlag = false;

    public FileMapDao(DataSource ds) throws Exception {
        super(ds);
		if (!initFlag) initTable();
    }

    protected void initTable() throws Exception {
        String createQuery = null;
        String insertQuery = null;
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;

        try {
            con = this.getConnection();
            con.setAutoCommit(false);

            // init data table
            if (this.isTableExist(null, null, "TAB_PORTAL_FILE_MAP", null)) {
                System.out.println("tab_portal_file_map table is exist");
            } else {
                System.out.println("tab_portal_file_map table is not exist");
                createQuery = "create table tab_portal_file_map (map_id number(10) constraint tab_portal_file_pk primary key, board_id number(10) not null, post_id number(10) not null, file_id number(10) not null)";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();
            }

            // init sequence table
            if (this.isTableExist(null, null, "TAB_PORTAL_FILE_MAP_SEQUENCE", null)) {
				System.out.println("tab_portal_file_map_sequence table is exist");

            } else {
                System.out.println("tab_portal_file_map_sequence table is not exist");

                createQuery = "create table tab_portal_file_map_sequence (sequence int)";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();


            }

            selectQuery = "select count(*) total_count from tab_portal_file_map_sequence";
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();
            
            if (rs.next()) {

                int totalCount = rs.getInt("total_count");
                if (totalCount > 1) {
                    System.out.println("sequcen table is not empty");
                    throw new Exception();
                } else if (totalCount == 0) {
					System.out.println("sequcen table is empty");
					insertQuery = "insert into tab_portal_file_map_sequence values (0)";
					ps = con.prepareStatement(insertQuery);
					ps.executeQuery();
                }
            } else {
                System.out.println("sequcen table is empty");
                insertQuery = "insert into tab_portal_file_map_sequence values (0)";
                ps = con.prepareStatement(insertQuery);
                ps.executeQuery();
            }

            con.commit();
            con.setAutoCommit(true);
            this.initFlag = true;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    // case: automatic key generation is not supported
    public int getNextSequence() throws Exception {
        String selectQuery = null;
        String updateQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int sequence = 0;
        
        try {
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select max(sequence)+1 next_sequence from tab_portal_file_map_sequence";
            ps = con.prepareStatement(selectQuery);
	        rs = ps.executeQuery();
			if (rs.next() == false) throw new Exception();
			sequence = rs.getInt("next_sequence");

            System.out.println("next sequence: "+sequence);
            
            updateQuery = "update tab_portal_file_map_sequence set sequence = ?";
			ps = con.prepareStatement(updateQuery);
			ps.setInt(1, sequence);

			if (ps.executeUpdate() != 1) throw new Exception();
            con.commit();
            con.setAutoCommit(true);
 			return sequence;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public FileMapVo[] getFileMapVoArray() throws Exception {
        return this.getFileMapVoArray(null);
    }

    public FileMapVo[] getFileMapVoArray(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select * from tab_portal_file_map ";
            else selectQuery = "select * from tab_portal_file_map " + wherePhrase;
            ps = con.prepareStatement(selectQuery, ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);

            Vector vector = new Vector();
            while (rs.next()) {
                FileMapVo fileMapVo = new FileMapVo();
                
                int mapId = rs.getInt("map_id");
                if (rs.wasNull()) fileMapVo.setMapId(null);
                else fileMapVo.setMapId(new Integer(mapId));

				int boardId = rs.getInt("board_id");
                if (rs.wasNull()) fileMapVo.setBoardId(null);
                else fileMapVo.setBoardId(new Integer(boardId));

				int postId = rs.getInt("post_id");
                if (rs.wasNull()) fileMapVo.setPostId(null);
                else fileMapVo.setPostId(new Integer(postId));

                int fileId = rs.getInt("file_id");
                if (rs.wasNull()) fileMapVo.setFileId(null);
                else fileMapVo.setFileId(new Integer(fileId));

                vector.add(fileMapVo);
            }
            return (FileMapVo[]) vector.toArray(new FileMapVo[vector.size()]);
        } catch (SQLException ex) {
            System.out.println("query: "+selectQuery);
            ex.printStackTrace();
            throw ex;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public int removeEmptyFile() {
        return 0;
    }

    public int getNumberOfFileMaps(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select count(*) number_of_file_map from tab_portal_file_map ";
            else selectQuery = "select count(*) number_of_file_map from tab_portal_file_map " + wherePhrase;
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);
            
            return rs.getInt("number_of_file_map");
        } catch (SQLException ex) {
            System.out.println("query: "+selectQuery);
            throw ex;
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public int getNumberOfFileMaps() throws Exception {
        return this.getNumberOfFileMaps(null);
    }
}
