/* Generated by Together */

package com.sds.portal.file.delegate;

import javax.naming.*;

import com.sds.portal.file.FileInterface;
import com.sds.portal.file.facade.*;
import com.sds.portal.file.vo.*;
import com.sds.common.delegate.Delegate;
import com.sds.common.util.*;

public class FileDelegate extends Delegate implements FileInterface {

	private FileFacadeLocal facadeLocalObject = null;
	private FileFacade facadeRemoteObject = null;

    public FileDelegate(Boolean isLocalInterface) throws Exception {
        super(isLocalInterface);

        Locator locator = Locator.getInstance();
        // for portability, jndi name is retrieved from env-entry

        if (this.isLocalInterface) { 
    		String facadeLocalJndiName = (String) locator.lookup("java:comp/env/file/fileFacadeLocalJndiName");
	    	facadeLocalObject = ((FileFacadeLocalHome) locator.getLocalHome(facadeLocalJndiName)).create();
        } else {
            String facadeRemoteJndiName = (String) locator.lookup("java:comp/env/file/fileFacadeRemoteJndiName");
	    	facadeRemoteObject = ((FileFacadeHome) locator.getRemoteHome(facadeRemoteJndiName)).create();
        }
	
		// ejb-ref lookup (name only) : doesn't work (only servlet, jsp ejb-ref works)
		//facadeLocalObject = ((FileFacadeLocalHome) locator.getLocalHome("ejb/fileFacadeLocalRef")).create();
	
		// ejb-ref lookup (full path) : doesn't works (only servlet, jsp ejb-ref works)
		//facadeLocalObject = ((FileFacadeLocalHome) locator.getLocalHome("java:comp/env/ejb/fileFacadeLocalRef")).create();
	
		// jndi lookup (name only): works
		//facadeLocalObject = ((FileFacadeLocalHome) locator.getLocalHome("com.sds.portal.file.facade.FileFacadeBean")).create();
	
		// jndi lookup (full path): doesn't work
		//facadeLocalObject = ((FileFacadeLocalHome) locator.getLocalHome("java:comp/env/com.sds.portal.file.facade.FileFacadeBean")).create();
    }

    public void delete(Integer fileId) throws Exception {
        if (this.isLocalInterface) facadeLocalObject.delete(fileId);
        else facadeRemoteObject.delete(fileId);
    }

    public Integer upload(FileVo fileVo) throws Exception  {
        if (this.isLocalInterface) return facadeLocalObject.upload(fileVo);
		else return facadeRemoteObject.upload(fileVo);
    }

    public Integer[] upload(FileVo[] fileVoArray) throws Exception  {
        if (this.isLocalInterface) return facadeLocalObject.upload(fileVoArray);
		else return facadeRemoteObject.upload(fileVoArray);
    }

    public void increaseDownloads(Integer fileId) throws Exception  {
        if (this.isLocalInterface) facadeLocalObject.increaseDownloads(fileId);
        else facadeRemoteObject.increaseDownloads(fileId);
    }

    public FileVo getFileVo(Integer fileId) throws Exception  {
        if (this.isLocalInterface) return facadeLocalObject.getFileVo(fileId);
        else return facadeRemoteObject.getFileVo(fileId);
    }

    public FileVo[] getFileVoArray() throws Exception {
        if (this.isLocalInterface) return facadeLocalObject.getFileVoArray();
        else return facadeRemoteObject.getFileVoArray();
    }

    public FileVo[] getFileVoArray(String wherePhrase) throws Exception {
        if (this.isLocalInterface) return facadeLocalObject.getFileVoArray(wherePhrase);
        else return facadeRemoteObject.getFileVoArray(wherePhrase);
    }

    public int getNumberOfFiles() throws Exception {
        if (this.isLocalInterface) return facadeLocalObject.getNumberOfFiles();
        else return facadeRemoteObject.getNumberOfFiles();
    }

    public int getNumberOfFiles(String wherePhrase) throws Exception{
        if (this.isLocalInterface) return facadeLocalObject.getNumberOfFiles(wherePhrase);
        else return facadeRemoteObject.getNumberOfFiles(wherePhrase);
    }

}
