/* Generated by Together */

package com.sds.portal.file.facade;


import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.CreateException;
import javax.naming.*;
import javax.sql.*;
import javax.ejb.*;

import com.sds.portal.file.dao.FileDao;
import com.sds.portal.file.FileInterface;
import com.sds.portal.file.entity.*;
import com.sds.portal.file.vo.FileVo;
import com.sds.common.util.*;

/**
 * @ejbHome <{com.sds.portal.file.facade.FileFacadeHome}>
 * @ejbRemote <{com.sds.portal.file.facade.FileFacade}>
 * @ejbTransactionAttribute Required
 * @displayName File Facade 
 * @ejbLocal <{FileFacadeLocal}>
 * @ejbLocalHome <{FileFacadeLocalHome}>
 * @undefined
 * @ejbBeanIdentifier FileFacade*/
public class FileFacadeBean implements SessionBean, FileInterface {
    private SessionContext ctx;

    /** @link dependency 
     * @stereotype use*/
    /*# FileVo lnkFileVo; */

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileEntityLocal fileEntityLocal;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileEntityLocalHome fileEntityLocalHome;

    private FileDao fileDao = null;

    public void setSessionContext(SessionContext context) throws RemoteException, EJBException {
        ctx = context;
    }

    public void ejbActivate() throws EJBException {
    }

    public void ejbPassivate() throws EJBException {
    }

    public void ejbRemove() throws EJBException {
    }

    public void ejbCreate() throws CreateException, EJBException {
        try {
            DataSource ds = (DataSource) Locator.getInstance().lookup("java:comp/env/jdbc/dataSourceRef");
            if (ds == null) throw new Exception("datasource is null");
            fileDao = new FileDao(ds);

            // ejb-ref lookup (name only) : doesn't work
            //fileEntityLocalHome = (FileEntityLocalHome) Locator.getInstance().getLocalHome("ejb/fileEntityLocalRef");

            // ejb-ref lookup (full path) : works
            fileEntityLocalHome = (FileEntityLocalHome) Locator.getInstance().getLocalHome("java:comp/env/ejb/fileEntityLocalRef");

            // jndi lookup (name only): works
            //fileEntityLocalHome = (FileEntityLocalHome) Locator.getInstance().getLocalHome("com.sds.portal.file.entity.FileEntityBean");

            // jndi lookup (full path): doesn't work
            //fileEntityLocalHome = (FileEntityLocalHome) Locator.getInstance().getLocalHome("java:comp/env/com.sds.portal.file.entity.FileEntityBean");

        } catch (NamingException ex) {
            ex.printStackTrace();
            throw new EJBException();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public Integer upload(FileVo fileVo) throws EJBException {
        try {
            Integer fileId = new Integer(fileDao.getNextSequence());

            // manual primary key generation
            fileVo.setFileId(fileId);
            // auto primary key generation
            ;

            fileEntityLocalHome.create(fileVo);
			return fileId;

        } catch (NamingException ex) {
            ex.printStackTrace();
            throw new EJBException();
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public void increaseDownloads(Integer fileId) throws EJBException {
        try {
            fileEntityLocal = fileEntityLocalHome.findByPrimaryKey(fileId);
            Integer downloads = fileEntityLocal.getDownloads();
            fileEntityLocal.setDownloads(new Integer(downloads.intValue() + 1));
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public FileVo getFileVo(Integer fileId) throws EJBException {
        try {
            try {
	            fileEntityLocal = fileEntityLocalHome.findByPrimaryKey(fileId);
            } catch (FinderException ex) {
                return null;
            }
            FileVo fileVo = new FileVo();
            fileVo.setFileId(fileEntityLocal.getFileId());
            fileVo.setOriginalFileName(fileEntityLocal.getOriginalFileName());
            fileVo.setAliasFileName(fileEntityLocal.getAliasFileName());
            fileVo.setRepositoryPath(fileEntityLocal.getRepositoryPath());
            fileVo.setFileSize(fileEntityLocal.getFileSize());
            fileVo.setDownloads(fileEntityLocal.getDownloads());
            return fileVo;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }

    }

    public int getNumberOfFiles() throws EJBException {
        try {
            return fileDao.getNumberOfFiles();
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public int getNumberOfFiles(String wherePhrase) throws EJBException {
        try {
            return fileDao.getNumberOfFiles(wherePhrase);
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public FileVo[] getFileVoArray() throws EJBException {
        try {
            return fileDao.getFileVoArray();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public FileVo[] getFileVoArray(String wherePhrase) throws EJBException {
        try {
            return fileDao.getFileVoArray(wherePhrase);
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public void delete(Integer fileId) throws EJBException {
        try {
            fileEntityLocal = fileEntityLocalHome.findByPrimaryKey(fileId);
            fileEntityLocal.remove();
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public Integer[] upload(FileVo[] fileVoArray){
        Integer[] tmpIntegerArray = new Integer[fileVoArray.length];
        for (int i=0; i<fileVoArray.length; i++) {
			tmpIntegerArray[i] = this.upload(fileVoArray[i]);
        }
        return tmpIntegerArray;
    }
}
