/* Generated by Together */

package com.sds.portal.post.delegate;

import com.sds.common.delegate.Delegate;
import com.sds.portal.post.QNAFileInterface;
import com.sds.portal.post.facade.*;
import com.sds.portal.post.vo.*;
import com.sds.portal.file.vo.*;
import com.sds.common.util.*;

public class QNAFileDelegate extends Delegate implements QNAFileInterface {
    public QNAFileDelegate(Boolean isLocalInterface) throws Exception {
        super(isLocalInterface);

        Locator locator = Locator.getInstance();
        // for portability, jndi name is retrieved from env-entry

        if (this.isLocalInterface) {
            String facadeLocalJndiName = (String) locator.lookup("java:comp/env/qnaFile/qnaFileFacadeLocalJndiName");
            facadeLocalObject = ((QNAFileFacadeLocalHome) locator.getLocalHome(facadeLocalJndiName)).create();
        } else {
            String facadeRemoteJndiName = (String) locator.lookup("java:comp/env/qnaFile/qnaFileFacadeRemoteJndiName");
            facadeRemoteObject = ((QNAFileFacadeHome) locator.getRemoteHome(facadeRemoteJndiName)).create();
    	}
    }

    public int getNumberOfPosts() throws Exception {
        if (this.isLocalInterface) return facadeLocalObject.getNumberOfPosts();
        else return facadeRemoteObject.getNumberOfPosts();
    }

    public void deleteQNA(Integer postId) throws Exception {
        if (this.isLocalInterface) facadeLocalObject.deleteQNA(postId);
        else facadeRemoteObject.deleteQNA(postId);
    }

    public CompleteQNAFileVo getCompleteQNAFileVo(Integer postId) throws Exception  {
        if (this.isLocalInterface) return facadeLocalObject.getCompleteQNAFileVo(postId);
        else return facadeRemoteObject.getCompleteQNAFileVo(postId);
    }

    public CompleteQNAFileVo[] getCompleteQNAFileVoArray(int bundleIndex, int fetchSize, String wherePhrase)  throws Exception{
        if (this.isLocalInterface) return facadeLocalObject.getCompleteQNAFileVoArray(bundleIndex, fetchSize, wherePhrase);
        else return facadeRemoteObject.getCompleteQNAFileVoArray(bundleIndex, fetchSize, wherePhrase);
    }

    public int getNumberOfPosts(String wherePhrase)  throws Exception{
        if (this.isLocalInterface) return facadeLocalObject.getNumberOfPosts(wherePhrase);
        else return facadeRemoteObject.getNumberOfPosts(wherePhrase);
    }

    public void post(CompleteQNAFileVo qnaFileVo) throws Exception  {
        if (this.isLocalInterface) facadeLocalObject.post(qnaFileVo);
        else facadeRemoteObject.post(qnaFileVo);
    }

    public void reply(CompleteQNAFileVo qnaFileVo) throws Exception{
        if (this.isLocalInterface) facadeLocalObject.reply(qnaFileVo);
        else facadeRemoteObject.reply(qnaFileVo);
    }

    public void update(CompleteQNAFileVo qnaFileVo) throws Exception {
        if (this.isLocalInterface) facadeLocalObject.update(qnaFileVo);
        else facadeRemoteObject.update(qnaFileVo);
    }

    public CompleteQNAFileVo read(Integer postId) throws Exception {
        if (this.isLocalInterface) return facadeLocalObject.read(postId);
        else return facadeRemoteObject.read(postId);
    }

    public CompleteQNAFileVo[] list(int bundleIndex, int fetchSize, String wherePhrase) throws Exception {
        if (this.isLocalInterface) return facadeLocalObject.list(bundleIndex, fetchSize, wherePhrase);
        else return facadeRemoteObject.list(bundleIndex, fetchSize, wherePhrase);
    }

    public void deleteFile(Integer fileId) throws Exception {
        if (this.isLocalInterface) facadeLocalObject.deleteFile(fileId);
        else facadeRemoteObject.deleteFile(fileId);
    }

	private QNAFileFacadeLocal facadeLocalObject = null;
    private QNAFileFacade facadeRemoteObject = null;
}
