// dependency: dom_utility.js
var domUtility = new DomUtility();

// dependency: string_utility.js
var stringUtility = new StringUtility();

// init buttonList
function initButtonList() {
    var buttonList = new Array();
    var elements = document.getElementsByTagName("div");
    for (var i=0; i<elements.length; i++) {
        var regExp = new RegExp("button", "i");
        if (regExp.test(elements[i].id)) {
            buttonList[elements[i].id] = new Button(elements[i]);
        }
    }
    return buttonList;
} 


// button object
function Button(divElement) {

    // attribute
    this.htmlElement = divElement;

    // attribute
    this.buttonIcon = domUtility.getElementByClassName(divElement, "button_icon");
    this.buttonCaption = domUtility.getElementByClassName(divElement, "button_caption");

    // attribute (flag)
    this.isActive = true;

    // method (member function)
    this.activate = activate;
    this.deactivate = deactivate;

    // method (event handler)
    this.htmlElement.onmousedown = pressButton;
    this.htmlElement.onmouseup = releaseButton;
    this.htmlElement.onmouseout = releaseButton;
    
    // variable (for parameter of method)
    var htmlElement = this.htmlElement;
    var buttonIcon = this.buttonIcon;

    // method
    function pressButton() {
        if (htmlElement != null)
        htmlElement.className = stringUtility.regexpReplace(htmlElement.className, "button" , "button_mouse_down");
        
        if (buttonIcon != null)
        buttonIcon.className = stringUtility.regexpReplace(buttonIcon.className, "icon" , "icon_mouse_down");
    }

    function releaseButton() {
        if (htmlElement != null)
        htmlElement.className = stringUtility.regexpReplace(htmlElement.className, "button" , "button_mouse_up");
        if (buttonIcon != null)
        buttonIcon.className = stringUtility.regexpReplace(buttonIcon.className, "icon" , "icon_mouse_up");
    }

    function activate() {
        this.isActive = true;
        htmlElement.className = stringUtility.regexpReplace(htmlElement.className, "button" , "button_activated");
    }

    function deactivate() {
        this.isActive = false;
        htmlElement.className = stringUtility.regexpReplace(htmlElement.className, "button" , "button_deactivated");
    }
}



