function FormUtility() {
    // method
    this.addInputFormField = addInputFormField;
    this.checkInputForm = checkInputForm;
    
    // add input field dynamically
    // filed name pattern is '*\d$', postfix is digit.
    // added input field id/name is increased by 1.
    // i.e. if 'xxx_1' exist, 'xxx_2' is added.
    function addInputFormField(divId, inputType) {
        var divElement = document.getElementById(divId);
        var childElements = divElement.childNodes;

        var fieldId = null;
        var fieldName = null;
        var newFieldId = null;
        var newFieldName = null;
        
        for (var i =0; i<childElements.length; i++) {
            if (childElements[i].type == inputType) {
                fieldName = childElements[i].name;
                fieldId = childElements[i].id;
            }
        }

        if (fieldId != null && fieldId != "") {
            var regExp = new RegExp("\\d$");
            var resultArrayForId = regExp.exec(fieldId);
            newFieldId = fieldId.replace(/(\d)$/, eval(resultArrayForId[0])+1);
            
            var inputElement = document.createElement('input');
            inputElement.type = inputType;
            inputElement.id = newFieldId;
            divElement.appendChild(inputElement);
        }
        
        if (fieldName != null && fieldName != "") {
            var regExp = new RegExp("\\d$");
            var resultArrayForName = regExp.exec(fieldName);
            newFieldName = fieldName.replace(/(\d)$/, eval(resultArrayForName[0])+1);
            
            var inputElement = document.createElement('input');
            inputElement.type = inputType;
            inputElement.name = newFieldName;
            divElement.appendChild(inputElement);
        }
    }

    // check input form field (for debugging)
    function checkInputForm() {
        var inputElements = document.getElementsByTagName('input');
        var msg = "[input form check]\n\n";
        for (var i=0; i<inputElements.length; i++) {
            msg += "type: "+ inputElements[i].type+ ", id: "+inputElements[i].id + ", name: "+inputElements[i].name +"\n";
        }
        alert(msg);
    }
}
