// dependency: browser.js
var browser = new Browser();

// dependency: client
var client = new Client();

// slidebar object
function SlideBar() {
    // attribute: variable
    this.id;
    this.left;
    this.top;
    this.width;
    this.height;
    this.moveOffset;
    this.moveInterval;
    this.timer;
    
    // attribute: inner object
    this.thumbLeft = new Thumb();
    this.body = new Body();
    this.thumbRight = new Thumb();
    
    // method
    this.init = init;
    this.redraw = redraw;
    this.setConfig = setConfig;
    this.slideIn = slideIn;
    this.slideOut = slideOut;
    this.moveLeft = moveLeft;
    this.moveRight = moveRight;
}

// slidebar method
function init() {
    this.redraw();
    document.getElementById(this.id).style.visibility = "visible";
}
function redraw() {
    with (document.getElementById(this.id)) {
        style.height = this.height;
        if (browser.isIE) {
            style.width = client.getInnerWidth();
            style.top = client.getInnerHeight() + client.getPageYOffset() - parseInt(this.height);
        }
        if (browser.isNS) {
            style.width = client.getInnerWidth() - 20;
            style.top = client.getInnerHeight() + client.getPageYOffset() - parseInt(this.height) - 20;
        }
    }
    with (document.getElementById(this.thumbLeft.id)) {
        style.width = this.thumbLeft.width;
        style.height = this.thumbLeft.height;
        if (this.thumbLeft.isEnable) {
            style.backgroundImage = "url(../images/slidebar/arrow_left_enabled.png)";
        } else {
            style.backgroundImage = "url(../images/slidebar/arrow_left_disabled.png)";
        }
    }
    with (document.getElementById(this.thumbRight.id)) {
        style.width = this.thumbRight.width;
        style.height = this.thumbRight.height;
        if (this.thumbRight.isEnable) {
            style.backgroundImage = "url(../images/slidebar/arrow_right_enabled.png)";
        } else {
            style.backgroundImage = "url(../images/slidebar/arrow_right_disabled.png)";
        }
    }
}
function setConfig(config) {
    this.id = config.id;

    this.height = config.height;
    this.moveOffset = config.moveOffset;
    this.moveInterval = config.moveInterval;
    
    this.thumbLeft.id = config.thumbLeft.id;
    this.thumbLeft.width = config.thumbLeft.width;
    this.thumbLeft.height = config.thumbLeft.height;
    this.thumbLeft.isEnable = config.thumbLeft.isEnable;
    this.thumbLeft.imageEnabled = config.thumbLeft.imageEnabled;
    this.thumbLeft.imageDisabled = config.thumbLeft.imageDisabled;

    this.body.id = config.body.id;
    
    this.thumbRight.id = config.thumbRight.id;
    this.thumbRight.width = config.thumbRight.width;
    this.thumbRight.height = config.thumbRight.height;
    this.thumbRight.isEnable = config.thumbRight.isEnable;
    this.thumbRight.imageEnabled = config.thumbRight.imageEnabled;
    this.thumbRight.imageDisabled = config.thumbRight.imageDisabled;
}
function moveLeft() {
}
function moveRight() {
}
function slideIn() {
}
function slideOut() {
}








// config object
function SlideBarConfig() {
    this.height = 50;
    this.moveOffset = 50;
    this.moveInterval = 1;

    this.thumbLeft = new Thumb();
    this.thumbLeft.id;
    this.thumbLeft.width = 20;
    this.thumbLeft.height = 50;
    this.thumbLeft.isEnable = true;
    this.thumbLeft.imageEnabled = "../images/slidebar/arrow_left_enabled.png";
    this.thumbLeft.imageDisabled = "../images/slidebar/arrow_right_enabled.png";
    
    this.body = new Body();
    this.body.id;
    
    this.thumbRight = new Thumb();
    this.thumbRight.id;
    this.thumbRight.width = 20;
    this.thumbRight.height = 50;
    this.thumbRight.isEnable = false;
    this.thumbRight.imageEnabled = "../images/slidebar/arrow_right_enabled.png";
    this.thumbRight.imageDisabled = "../images/slidebar/arrow_right_enabled.png";
}





// thumb object
function Thumb() {
    this.id;
    this.width;
    this.height;
    this.isEnable;
    this.imageEnabled;
    this.imageDisabled;
}

// body object
function Body() {
    this.id;
}


