function getCookie(name) {
    var cookieString = document.cookie;
    var keyStartIndex = 0;
    var keyEndIndex = 0;
    var valueStartIndex = 0;
    var valueEndIndex = 0;
    for (i=0; i<cookieString.length; i++) {
        keyStartIndex = i;
        keyEndIndex = keyStartIndex + name.length;
        if (keyEndIndex >= cookieString.length) return null;
        if (cookieString.substring(keyStartIndex, keyEndIndex) == name) {
            valueStartIndex = document.cookie.indexOf("=", keyEndIndex)+1;
            valueEndIndex = document.cookie.indexOf(";", keyEndIndex);
            if (valueStartIndex > valueEndIndex) valueEndIndex = cookieString.length;
            return unescape(document.cookie.substring(valueStartIndex, valueEndIndex));
        }
    }
    return null;
}

function setCookie(name, value, expires, path, domain, secure) {
    var cookieString = "";
    if (name != null && name.length > 0 && value != null && value.length > 0) {
        cookieString += name + "=" +escape(value); 
        cookieString += (expires != null && expires.length > 0)? "; expires="+expires : "; expires="+getDefaultExpireTime();
        cookieString += (path != null && path.length > 0)? "; path="+path : "";
        cookieString += (domain != null && domain.length > 0)? "; domain="+domain : "";
        cookieString += (secure != null && secure.length > 0)? "; secure" : "";
        document.cookie = cookieString;
    } else {
        alert("name and value should be filled");    
    }
}

function deleteCookie(name, path, domain) {
    if (getCookie(name)) {
        setCookie(name, "dummy", (new Date()).toGMTString(), path, domain, null);
    }
}

function getDefaultExpireTime() {
        var expireTime = new Date();
        expireTime.setTime((new Date()).getTime()+(365 * 24 * 60 * 60 * 1000));
        return expireTime.toGMTString();
}
