/* Generated by Together */

package com.sds.common.controller;

import javax.servlet.http.*;
import java.util.*;

import org.apache.commons.fileupload.*;
import com.oreilly.servlet.*;
import org.w3c.util.UUID;

public class TransactionTokenHelper {
    public void saveToken(HttpServletRequest req) throws Exception {
        HttpSession session = req.getSession(false);
        if (session == null) throw new InvalidSessionException();
        // share token
        String issuedToken = this.generateToken();
		session.setAttribute(this.ATTRIB_TRANSACTION_TOKEN, issuedToken);
		req.setAttribute(this.ATTRIB_TRANSACTION_TOKEN, issuedToken);
        System.out.println("issued token: "+issuedToken);
    }

    public void checkToken(HttpServletRequest req) throws Exception {
        HttpServletRequest tmpReq = req;
        String parameterName = null;
		String parameterValue = null;
		String transactionToken = null;

        HttpSession session = tmpReq.getSession(true);
        if (session == null) throw new InvalidSessionException();
        transactionToken = (String) session.getAttribute(this.ATTRIB_TRANSACTION_TOKEN);

        // parse request to fetch transaction token
		boolean isMultiPart = FileUploadBase.isMultipartContent(tmpReq);

		if (!isMultiPart) {
			ParameterParser parser = new ParameterParser(tmpReq);
			parameterName = this.PARAM_TRANSACTION_TOKEN;
            try {
				parameterValue = parser.getStringParameter(parameterName);
            } catch (Exception ex) {}
		} else {
			DiskFileUpload diskUpload = new DiskFileUpload();
			List items = diskUpload.parseRequest(tmpReq);
			Iterator it = items.iterator();

			while (it.hasNext()) {
				FileItem item = (FileItem) it.next();
				if (!item.isFormField()) {
					// skip file item
				} else {
					parameterName = item.getFieldName();
					parameterValue = item.getString();
                    if (parameterName.equals(this.PARAM_TRANSACTION_TOKEN)) break;
					System.out.println("[request dump] parameter name: " + parameterName + ", value: " + parameterValue);
				}
			}
		}

		// check token
		if (parameterValue == null) {
            if (transactionToken == null) {
                // initial access from client
                // (direct link access)
                System.out.println("[token check] initial access from client");
                System.out.println("client token: "+parameterValue+", server toekn: "+transactionToken);
                throw new InvalidTokenException();
            } else {
                // illegal access from client
                // (direct link access)
                System.out.println("[token check] illegal access from client");
                System.out.println("client token: "+parameterValue+", server toekn: "+transactionToken);
                //  ʿҰ    Ǵ 
                // : direct link access
                throw new InvalidTokenException();
            }
		} else {
            if (parameterValue.equals(transactionToken)) {
                // legal access from client
                System.out.println("[token check] legal access from client");
                System.out.println("client token: "+parameterValue+", server toekn: "+transactionToken);
            } else {
                // duplicated access from client
                // (reload)
                System.out.println("[token check] duplicated access from client");
                System.out.println("client token: "+parameterValue+", server toekn: "+transactionToken);
                // reloadable   Ȯ   Ǵ 
                throw new DuplicatedTransactionException();
            }
		}
    }

    private String generateToken() {
        return (new UUID()).toString();
    }

    public static final String PARAM_TRANSACTION_TOKEN = "submittedToken";
    public static final String ATTRIB_TRANSACTION_TOKEN = "issuedToken";
}
