/* Generated by Together */

package com.sds.common.dao;

import java.sql.*;
import javax.sql.*;
import com.sds.common.util.Locator;


public abstract class Dao {
    protected DataSource ds = null;

    public Dao(DataSource ds) throws Exception {
        this.ds = ds;
    }
    public abstract int getNextSequence() throws Exception;
	protected abstract void initTable() throws Exception;

	/**
     * @param catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
     * @param schemaPattern - a schema name pattern; "" retrieves those without a schema
     * @param tableNamePattern - a table name pattern
     * @param types - a list of table types to include; null returns all types
     */
    protected boolean isTableExist(String catalog, String schemaPattern, String tableNamePattern, String[] types) throws Exception {
        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;

        try {
            ds = (DataSource) Locator.getInstance().lookup("jdbc/viperTxDs");
            con = ds.getConnection();
            metaData = con.getMetaData();
            rs = metaData.getTables(catalog, schemaPattern, tableNamePattern, types);
            if (rs.next()) return true;
            else return false;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (con != null) con.close();
        }
    }

    protected Connection getConnection() throws Exception {
        return ds.getConnection();
    }
}
