/* Generated by Together */

package com.sds.portal.board.dao;

import java.sql.*;
import javax.sql.*;
import java.util.*;

import com.sds.common.dao.Dao;
import com.sds.portal.board.vo.BoardVo;

public class BoardDao extends Dao {
    private static boolean initFlag = false;

    public BoardDao(DataSource ds) throws Exception {
        super(ds);
		if (!initFlag) initTable();
    }

    protected void initTable() throws Exception {
        String createQuery = null;
        String insertQuery = null;
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;

        try {
            /*
            con = this.getConnection();
            con.setAutoCommit(false);

            // init data table
            if (this.isTableExist(null, null, "TAB_PORTAL_BOARD", null)) {
                System.out.println("tab_portal_board table is exist");
            } else {
                System.out.println("tab_portal_board table is not exist");
                createQuery = "create table tab_portal_board (board_id number(10) constraint tab_portal_board_pk primary key, repository_path varchar2(100) not null, alias_board_name varchar2(100) not null, original_board_name varchar2(100) not null, board_size number(10) not null, downloads number(10))";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();
            }

            // init sequence table
            if (this.isTableExist(null, null, "TAB_PORTAL_BOARD_SEQUENCE", null)) {
				System.out.println("tab_portal_board_sequence table is exist");

            } else {
                System.out.println("tab_portal_board_sequence table is not exist");

                createQuery = "create table tab_portal_board_sequence (sequence int)";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();


            }

            selectQuery = "select count(*) total_count from tab_portal_board_sequence";
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();
            
            if (rs.next()) {

                int totalCount = rs.getInt("total_count");
                if (totalCount > 1) {
                    System.out.println("sequcen table is not empty");
                    throw new Exception();
                } else if (totalCount == 0) {
					System.out.println("sequcen table is empty");
					insertQuery = "insert into tab_portal_board_sequence values (0)";
					ps = con.prepareStatement(insertQuery);
					ps.executeQuery();
                }
            } else {
                System.out.println("sequcen table is empty");
                insertQuery = "insert into tab_portal_board_sequence values (0)";
                ps = con.prepareStatement(insertQuery);
                ps.executeQuery();
            }

            con.commit();
            con.setAutoCommit(true);
            this.initFlag = true;
            */
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    // case: automatic key generation is not supported
    public int getNextSequence() throws Exception {
        String selectQuery = null;
        String updateQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int sequence = 0;
        
        try {
            /*
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select max(sequence)+1 next_sequence from tab_portal_board_sequence";
            ps = con.prepareStatement(selectQuery);
	        rs = ps.executeQuery();
			if (rs.next() == false) throw new Exception();
			sequence = rs.getInt("next_sequence");

            System.out.println("next sequence: "+sequence);
            
            updateQuery = "update tab_portal_board_sequence set sequence = ?";
			ps = con.prepareStatement(updateQuery);
			ps.setInt(1, sequence);

			if (ps.executeUpdate() != 1) throw new Exception();
            con.commit();
            con.setAutoCommit(true);
            */
 			return sequence;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }    

    public int getNumberOfBoards() throws Exception {
        return this.getNumberOfBoards(null);
    }

    public int getNumberOfBoards(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select count(*) number_of_board from tab_portal_board ";
            else selectQuery = "select count(*) number_of_board from tab_portal_board " + wherePhrase;
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);
            
            return rs.getInt("number_of_board"); 
        } catch (SQLException ex) {
            throw ex;
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public BoardVo[] getBoardVoArray() throws Exception {
        return this.getBoardVoArray(null);
    }

    public BoardVo[] getBoardVoArray(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            Vector vector = new Vector();

            /*
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select * from tab_portal_board ";
            else selectQuery = "select * from tab_portal_board " + wherePhrase;
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);


            while (rs.next()) {
                BoardVo boardVo = new BoardVo();
                
                int boardId = rs.getInt("board_id");
                if (rs.wasNull()) boardVo.setBoardId(null);
                else boardVo.setBoardId(new Integer(boardId));

                String originalBoardName = rs.getString("original_board_name");
                boardVo.setOriginalBoardName(originalBoardName);
                    
                String aliasBoardName = rs.getString("alias_board_name");
                boardVo.setAliasBoardName(aliasBoardName);
                
                String repositoryPath = rs.getString("repository_path");
                boardVo.setRepositoryPath(repositoryPath);
                
                long boardSize = rs.getLong("board_size");
                if (rs.wasNull()) boardVo.setBoardSize(null);
                else boardVo.setBoardSize(new Long(boardSize));
                
                int downloads = rs.getInt("downloads");
                if (rs.wasNull()) boardVo.setDownloads(null);
                else boardVo.setDownloads(new Integer(downloads));

                vector.add(boardVo);
            }
            */
            return (BoardVo[]) vector.toArray(new BoardVo[vector.size()]);
            /*
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw ex;
            */
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }



    /** @link dependency
     * @stereotype use*/
    /*# com.sds.portal.board.vo.BoardVo lnkBoardVo; */    
}
