package com.sds.portal.file.command;

import java.io.*;
import java.util.*;
import javax.servlet.http.*;


import com.sds.portal.file.delegate.FileDelegate;
import com.sds.portal.file.vo.*;
import com.sds.common.command.Command;
import com.sds.common.util.*;

public class ListFileCmd extends Command {
    private String forwardPage;
    public final static String ATTRIB_ORPHAN_FILE_ID_VECTOR = "orphanFileIdVector";
    public final static String ATTRIB_FILE_VO_ARRAY = "fileVoArray";

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileDelegate fileDelegate;

    public ListFileCmd(String forwardPage) {
        super(forwardPage);
    }
    public ListFileCmd() {
        super();
    }

    public String execute(HttpServletRequest req, HttpServletResponse res) throws Exception {
        Locator locator = Locator.getInstance();

        // determin interface type
        Boolean isLocalInteface = (Boolean) locator.lookup("java:comp/env/file/isLocalInterface");

		// delegate
		fileDelegate = new FileDelegate(isLocalInteface);

        try {
            // execute bisiness logic
            FileVo[] fileVoArray = fileDelegate.getFileVoArray();

            String repositoryPath = null;
            String aliasFileName = null;
            Vector orphanFileIdVector = new Vector();
            for (int i=0; i<fileVoArray.length; i++) {
                repositoryPath = fileVoArray[i].getRepositoryPath();
                aliasFileName = fileVoArray[i].getAliasFileName();
				File tempFile = new File(repositoryPath + aliasFileName);

                //  vo    Ƽ  ȭ鿡 Ȯ  ֵ Ѵ.
                if (!tempFile.exists()) {
                    orphanFileIdVector.add(fileVoArray[i].getFileId());
                    /*
                    System.out.println(tempFile.getName()+" does not exist");
                    System.out.println(fileVoArray[i].toString());
                    */
                }
            }

            // set request
            req.setAttribute(this.ATTRIB_FILE_VO_ARRAY, fileVoArray);
            req.setAttribute(this.ATTRIB_ORPHAN_FILE_ID_VECTOR, orphanFileIdVector);

            return this.getForwardPage();
        } catch (Exception ex) {
            throw ex;
        }
    }    
}
