package com.sds.portal.file.command;

import java.io.*;
import java.util.*;
import javax.servlet.http.*;


import com.sds.portal.file.delegate.FileMapDelegate;
import com.sds.portal.file.vo.*;
import com.sds.common.command.Command;
import com.sds.common.util.*;

public class ListFileMapCmd extends Command {
    private String forwardPage;
    public final static String ATTRIB_FILE_MAP_VO_ARRAY = "fileMapVoArray";

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileMapDelegate fileMapDelegate;

    public ListFileMapCmd(String forwardPage) {
        super(forwardPage);
    }
    public ListFileMapCmd() {
        super();
    }

    public String execute(HttpServletRequest req, HttpServletResponse res) throws Exception {
        Locator locator = Locator.getInstance();

        // determin interface type
        Boolean isLocalInteface = (Boolean) locator.lookup("java:comp/env/file/isLocalInterface");

		// delegate
		fileMapDelegate = new FileMapDelegate(isLocalInteface);

        try {
            // execute bisiness logic
            FileMapVo[] fileMapVoArray = fileMapDelegate.getFileMapVoArray();

            // set request
            req.setAttribute(this.ATTRIB_FILE_MAP_VO_ARRAY, fileMapVoArray);

            return this.getForwardPage();
        } catch (Exception ex) {
            throw ex;
        }
    }    
}
