package com.sds.portal.file.command;

import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import javax.naming.*;
import javax.transaction.*;

import org.apache.commons.fileupload.*;

import com.sds.portal.file.delegate.FileDelegate;
import com.sds.portal.file.vo.*;
import com.sds.portal.file.*;
import com.sds.common.command.*;
import com.sds.common.util.*;

public class UploadFileCmd extends Command {


    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileDelegate fileDelegate;
    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private DiskFileHelper diskFileHelper = null;

	public UploadFileCmd() {
        super();
    }

    public UploadFileCmd(String forwardPage) {
        super(forwardPage);
    }

    public String execute(HttpServletRequest req, HttpServletResponse res) throws Exception {
		try {
            Locator locator = Locator.getInstance();
            Boolean isLocalInterface = (Boolean) locator.lookup("java:comp/env/file/isLocalInterface");
            fileDelegate = new FileDelegate(isLocalInterface);

            boolean isMultiPart = FileUpload.isMultipartContent(req);
            if (!isMultiPart) throw new EncTypeException("enctype should be 'multipart/form-data'");
            if (!req.getMethod().equals("POST")) throw new MethodException("method should be 'post'");
            
            DiskFileUpload diskUpload = new DiskFileUpload();
            List items = diskUpload.parseRequest(req);

            diskFileHelper = new DiskFileHelper();
            FileVo[] fileVoArray = diskFileHelper.upload(items);

            fileDelegate.upload(fileVoArray);

            // execute adapter
            try {
				String[] adapteeClassNames = (String[]) locator.lookup("java:comp/env/file/uploadFileCmdAdapteeClassNames", ",");
				Adapter adapter = new Adapter(req, res);
				adapter.executeAdapter(adapteeClassNames);
            } catch (NameNotFoundException ex) {
            } catch (Exception ex) {
                throw new Exception();
            }

            return this.getForwardPage();
        } catch (Exception ex) {
            ex.printStackTrace();
            diskFileHelper.delete();
            throw ex;
        }
    }
}
