/* Generated by Together */

package com.sds.portal.file.dao;

import java.sql.*;
import javax.sql.*;
import java.util.*;

import com.sds.common.dao.Dao;
import com.sds.portal.file.vo.*;

public class FileDao extends Dao {
    private static boolean initFlag = false;

    public FileDao(DataSource ds) throws Exception {
        super(ds);
		if (!initFlag) initTable();
    }

    protected void initTable() throws Exception {
        String createQuery = null;
        String insertQuery = null;
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;

        try {
            con = this.getConnection();
            con.setAutoCommit(false);

            // init data table
            if (this.isTableExist(null, null, "TAB_PORTAL_FILE", null)) {
                System.out.println("tab_portal_file table is exist");
            } else {
                System.out.println("tab_portal_file table is not exist");
                createQuery = "create table tab_portal_file (file_id number(10) constraint tab_portal_file_pk primary key, repository_path varchar2(100) not null, alias_file_name varchar2(100) not null, original_file_name varchar2(100) not null, file_size number(10) not null, downloads number(10))";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();
            }

            // init sequence table
            if (this.isTableExist(null, null, "TAB_PORTAL_FILE_SEQUENCE", null)) {
				System.out.println("tab_portal_file_sequence table is exist");

            } else {
                System.out.println("tab_portal_file_sequence table is not exist");

                createQuery = "create table tab_portal_file_sequence (sequence int)";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();


            }

            selectQuery = "select count(*) total_count from tab_portal_file_sequence";
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();
            
            if (rs.next()) {

                int totalCount = rs.getInt("total_count");
                if (totalCount > 1) {
                    System.out.println("sequcen table is not empty");
                    throw new Exception();
                } else if (totalCount == 0) {
					System.out.println("sequcen table is empty");
					insertQuery = "insert into tab_portal_file_sequence values (0)";
					ps = con.prepareStatement(insertQuery);
					ps.executeQuery();
                }
            } else {
                System.out.println("sequcen table is empty");
                insertQuery = "insert into tab_portal_file_sequence values (0)";
                ps = con.prepareStatement(insertQuery);
                ps.executeQuery();
            }

            con.commit();
            con.setAutoCommit(true);
            this.initFlag = true;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    // case: automatic key generation is not supported
    public int getNextSequence() throws Exception {
        String selectQuery = null;
        String updateQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int sequence = 0;
        
        try {
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select max(sequence)+1 next_sequence from tab_portal_file_sequence";
            ps = con.prepareStatement(selectQuery);
	        rs = ps.executeQuery();
			if (rs.next() == false) throw new Exception();
			sequence = rs.getInt("next_sequence");

            System.out.println("next sequence: "+sequence);
            
            updateQuery = "update tab_portal_file_sequence set sequence = ?";
			ps = con.prepareStatement(updateQuery);
			ps.setInt(1, sequence);

			if (ps.executeUpdate() != 1) throw new Exception();
            con.commit();
            con.setAutoCommit(true);
 			return sequence;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }    

    public int getNumberOfFiles() throws Exception {
        return this.getNumberOfFiles(null);
    }

    public int getNumberOfFiles(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select count(*) number_of_file from tab_portal_file ";
            else selectQuery = "select count(*) number_of_file from tab_portal_file " + wherePhrase;
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);
            
            return rs.getInt("number_of_file"); 
        } catch (SQLException ex) {
            System.out.println("query: "+selectQuery);
            throw ex;
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public FileVo[] getFileVoArray() throws Exception {
        return this.getFileVoArray(null);
    }

    public FileVo[] getFileVoArray(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select * from tab_portal_file ";
            else selectQuery = "select * from tab_portal_file " + wherePhrase;
            ps = con.prepareStatement(selectQuery, ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);

            Vector vector = new Vector();
            while (rs.next()) {
                FileVo fileVo = new FileVo();
                
                int fileId = rs.getInt("file_id");
                if (rs.wasNull()) fileVo.setFileId(null);
                else fileVo.setFileId(new Integer(fileId));

                String originalFileName = rs.getString("original_file_name");
                fileVo.setOriginalFileName(originalFileName);
                    
                String aliasFileName = rs.getString("alias_file_name");
                fileVo.setAliasFileName(aliasFileName);
                
                String repositoryPath = rs.getString("repository_path");
                fileVo.setRepositoryPath(repositoryPath);
                
                long fileSize = rs.getLong("file_size");
                if (rs.wasNull()) fileVo.setFileSize(null);
                else fileVo.setFileSize(new Long(fileSize));
                
                int downloads = rs.getInt("downloads");
                if (rs.wasNull()) fileVo.setDownloads(null);
                else fileVo.setDownloads(new Integer(downloads));

                vector.add(fileVo);
            }
            return (FileVo[]) vector.toArray(new FileVo[vector.size()]);
        } catch (SQLException ex) {
            System.out.println("query: "+selectQuery);
            ex.printStackTrace();
            throw ex;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public int removeEmptyFile() {
        return 0;
    }
}
