/* Generated by Together */

package com.sds.portal.file.facade;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.*;
import javax.ejb.EJBException;
import javax.ejb.CreateException;
import javax.sql.*;
import javax.naming.*;

import com.sds.common.util.*;
import com.sds.portal.file.FileMapInterface;
import com.sds.portal.file.vo.*;
import com.sds.portal.file.dao.FileMapDao;
import com.sds.portal.file.entity.*;

/**
 * @ejbHome <{com.sds.portal.file.facade.FileMapFacadeHome}>
 * @ejbRemote <{com.sds.portal.file.facade.FileMapFacade}> 
 * @ejbLocal <{FileMapFacadeLocal}>
 * @ejbLocalHome <{FileMapFacadeLocalHome}>
 * @ejbTransactionAttribute Required
 * @displayName FileMap Facade
 */
public class FileMapFacadeBean implements SessionBean, FileMapInterface {
    private SessionContext ctx;

    /**
     * @directed 
     */
    private FileMapDao fileMapDao;

    /** @link dependency 
     * @stereotype use*/
    /*# FileMapVo lnkFileMapVo; */

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileMapEntityLocalHome fileMapEntityLocalHome;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileMapEntityLocal fileMapEntityLocal;

    public void setSessionContext(SessionContext context) throws RemoteException, EJBException {
        ctx = context;
    }

    public void ejbActivate() throws EJBException {
    }

    public void ejbPassivate() throws EJBException {
    }

    public void ejbRemove() throws EJBException {
    }

    public void ejbCreate() throws CreateException, EJBException {
		try {
		DataSource ds = (DataSource) Locator.getInstance().lookup("java:comp/env/jdbc/dataSourceRef");
		if (ds == null) throw new Exception("datasource is null");
		fileMapDao = new FileMapDao(ds);

		fileMapEntityLocalHome = (FileMapEntityLocalHome) Locator.getInstance().getLocalHome("java:comp/env/ejb/fileMapEntityLocalRef");

        } catch (NamingException ex) {
            ex.printStackTrace();
            throw new EJBException();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public FileMapVo[] getFileMapVoArray() throws EJBException{
        try {
            return fileMapDao.getFileMapVoArray();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public int getNumberOfFileMaps() throws EJBException{
        try {
            return fileMapDao.getNumberOfFileMaps();
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

	public void delete(Integer mapId) throws EJBException{
        try {
            fileMapEntityLocal = fileMapEntityLocalHome.findByPrimaryKey(mapId);
            fileMapEntityLocal.remove();
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public FileMapVo getFileMapVo(Integer mapId) throws EJBException{
		try {
            FileMapVo fileMapVo = new FileMapVo();
            fileMapEntityLocal = fileMapEntityLocalHome.findByPrimaryKey(mapId);
            fileMapVo.setMapId(fileMapEntityLocal.getMapId());
            fileMapVo.setBoardId(fileMapEntityLocal.getBoardId());
            fileMapVo.setPostId(fileMapEntityLocal.getPostId());
            fileMapVo.setFileId(fileMapEntityLocal.getFileId());
            return fileMapVo;
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public FileMapVo[] getFileMapVoArray(String wherePhrase) throws EJBException{
        try {
            return fileMapDao.getFileMapVoArray(wherePhrase);
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public int getNumberOfFileMaps(String wherePhrase) throws EJBException{
        try {
            return fileMapDao.getNumberOfFileMaps(wherePhrase);
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public Integer map(FileMapVo fileMapVo) throws EJBException{
        try {
            Integer mapId = new Integer(fileMapDao.getNextSequence());

            // manual primary key generation
            fileMapVo.setMapId(mapId);
            // auto primary key generation
            ;

            fileMapEntityLocalHome.create(fileMapVo);
			return mapId;

        } catch (NamingException ex) {
            ex.printStackTrace();
            throw new EJBException();
        } catch (Exception ex) {
            throw new EJBException();
        }
    }
}
