/* Generated by Together */

package com.sds.portal.post.dao;

import javax.sql.*;
import java.sql.*;
import java.util.*;

import com.sds.portal.post.vo.CompleteQNAVo;
import com.sds.common.dao.Dao;

public class QNADao extends Dao {
    private static boolean initFlag = false;

    /** @link dependency 
     * @stereotype use*/
    /*# CompleteQNAVo lnkCompleteQNAVo; */

    public QNADao(DataSource ds) throws Exception {
        super(ds);
		if (!initFlag) initTable();
    }

    protected void initTable() throws Exception {
        String createQuery = null;
        String insertQuery = null;
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;

        try {
            con = this.getConnection();
            con.setAutoCommit(false);

            // init data table
            if (this.isTableExist(null, null, "TAB_PORTAL_QNA", null)) {
                System.out.println("tab_portal_qna table is exist");
            } else {
                System.out.println("tab_portal_qna table is not exist");
                createQuery = "create table tab_portal_qna ( post_id number(10) constraint tab_portal_qna_pk primary key, parent_post_id number(10), board_id number(10), author_id varchar2(50) not null, title varchar2(150) not null, content varchar2(150), ip_addr varchar2(15), mask_flag number(1), html_flag number(1),views number(10), thread_depth number(10) not null, priority number(10) not null, posted_date date not null, updated_date date)";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();
            }

            // init sequence table
            if (this.isTableExist(null, null, "TAB_PORTAL_QNA_SEQUENCE", null)) {
				System.out.println("tab_portal_qna_sequence table is exist");
            } else {
                System.out.println("tab_portal_qna_sequence table is not exist");
                createQuery = "create table tab_portal_qna_sequence (sequence int)";
                ps = con.prepareStatement(createQuery);
                ps.executeQuery();
            }

            selectQuery = "select count(*) total_count from tab_portal_qna_sequence";
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();
            
            if (rs.next()) {

                int totalCount = rs.getInt("total_count");
                if (totalCount > 1) {
                    System.out.println("sequcen table is not empty");
                    throw new Exception();
                } else if (totalCount == 0) {
					System.out.println("sequcen table is empty");
					insertQuery = "insert into tab_portal_qna_sequence values (0)";
					ps = con.prepareStatement(insertQuery);
					ps.executeQuery();
                }
            } else {
                System.out.println("sequcen table is empty");
                insertQuery = "insert into tab_portal_qna_sequence values (0)";
                ps = con.prepareStatement(insertQuery);
                ps.executeQuery();
            }

            con.commit();
            con.setAutoCommit(true);
            this.initFlag = true;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    // case: automatic key generation is not supported
    public int getNextSequence() throws Exception {
        String selectQuery = null;
        String updateQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int sequence = 0;
        
        try {
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select max(sequence)+1 next_sequence from tab_portal_qna_sequence";
            ps = con.prepareStatement(selectQuery);
	        rs = ps.executeQuery();
			if (rs.next() == false) throw new Exception();
			sequence = rs.getInt("next_sequence");

            System.out.println("next sequence: "+sequence);
            
            updateQuery = "update tab_portal_qna_sequence set sequence = ?";
			ps = con.prepareStatement(updateQuery);
			ps.setInt(1, sequence);

			if (ps.executeUpdate() != 1) throw new Exception();
            con.commit();
            con.setAutoCommit(true);
 			return sequence;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public void raisePriority(Integer lowerPostId) throws Exception {
		int tmpLowerPostId = lowerPostId.intValue();

        String updateQuery = null;
        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;

		try {
			con = this.getConnection();
            con.setAutoCommit(false);

            updateQuery = "update tab_portal_qna set priority = priority + 1 where board_id = (select board_id from tab_portal_qna where post_id = ?) and priority >= (select priority from tab_portal_qna where post_id = ?)";
            ps = con.prepareStatement(updateQuery);
            ps.setInt(1, tmpLowerPostId);
            ps.setInt(2, tmpLowerPostId);
	        int numOfupdated = ps.executeUpdate();
            System.out.println(numOfupdated + " post's priority are raised");
            
            con.commit();
            con.setAutoCommit(true);
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (ps != null) ps.close();
            if (con != null) con.close();
        }


    }

    public Integer getNextPriority(Integer boardId) throws Exception {

        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int tmpPriority = 0;
        int tmpBoardId = boardId.intValue();
        Integer priority = null;
        
        try {
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select max(priority)+1 next_priority from tab_portal_qna where board_id = ?";
            ps = con.prepareStatement(selectQuery);
            ps.setInt(1, tmpBoardId);
	        rs = ps.executeQuery();
			if (rs.next() == false) throw new Exception();
			tmpPriority = rs.getInt("next_priority");
            if (!rs.wasNull()) priority = new Integer(tmpPriority);
            else priority = new Integer(0);
            System.out.println("next priority: "+priority);
            
            con.commit();
            con.setAutoCommit(true);
 			return priority;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }        
    
    public Integer getFirstChildPostId(Integer parentPostId) throws Exception {

        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int tmpFirstChildPostId = 0;
        int tmpParentPostId = parentPostId.intValue();
        Integer firstChildPostId = null;
        
        try {
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select post_id from tab_portal_qna where parent_post_id = ? and priority = (select max(priority) from tab_portal_qna where parent_post_id = ?)";
            ps = con.prepareStatement(selectQuery);
            ps.setInt(1, tmpParentPostId);
            ps.setInt(2, tmpParentPostId);
	        rs = ps.executeQuery();
			if (rs.next() == false) throw new Exception();
			tmpFirstChildPostId = rs.getInt("post_id");
            if (!rs.wasNull()) firstChildPostId = new Integer(tmpFirstChildPostId);
            System.out.println("first child post id: "+firstChildPostId);
            
            con.commit();
            con.setAutoCommit(true);
 			return firstChildPostId;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }        
    
    public Integer getLastChildPostId(Integer parentPostId) throws Exception {

        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        ResultSet rs = null;
        PreparedStatement ps = null;        

        int tmpLastChildPostId = 0;
        int tmpParentPostId = parentPostId.intValue();
        Integer lastChildPostId = null;
        
        try {
			con = this.getConnection();
            con.setAutoCommit(false);

            selectQuery = "select post_id from tab_portal_qna where parent_post_id = ? and priority = (select min(priority) from tab_portal_qna where parent_post_id = ?)";
            ps = con.prepareStatement(selectQuery);
            ps.setInt(1, tmpParentPostId);
            ps.setInt(2, tmpParentPostId);
	        rs = ps.executeQuery();
			if (rs.next()) {
    			tmpLastChildPostId = rs.getInt("post_id");
                if (!rs.wasNull()) lastChildPostId = new Integer(tmpLastChildPostId);
            }
            System.out.println("last child post id: "+lastChildPostId);
            
            con.commit();
            con.setAutoCommit(true);
 			return lastChildPostId;
        } catch (Exception ex) {
            ex.printStackTrace();
			con.rollback();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }        

    public int getNumberOfQNAs() throws Exception {
        return this.getNumberOfQNAs(null);
    }

    public int getNumberOfQNAs(String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select count(*) number_of_qna from tab_portal_qna ";
            else selectQuery = "select count(*) number_of_qna from tab_portal_qna " + wherePhrase;
            ps = con.prepareStatement(selectQuery);
            rs = ps.executeQuery();
            rs.next();

            con.commit();
            con.setAutoCommit(true);
            
            return rs.getInt("number_of_qna"); 
        } catch (SQLException ex) {
            System.out.println("query: "+selectQuery);
            throw ex;
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }
    
    public int getNumberOfChildren(Integer postId) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;      

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            selectQuery = "select count(*) number_of_children from tab_portal_qna where parent_post_id = ?";
            ps = con.prepareStatement(selectQuery);
            ps.setInt(1, postId.intValue());
            rs = ps.executeQuery();
            rs.next();

            con.commit();
            con.setAutoCommit(true);

            return rs.getInt("number_of_children");
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw ex;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }

    public boolean hasChild(Integer postId) throws Exception {
        return (this.getNumberOfChildren(postId) > 0) ? true : false;
    }

    public int removeOrphanedPost() {
        return 0;
    }

    public CompleteQNAVo[] getCompleteQNAVoArray(int bundleIndex, int postBundleSize, String wherePhrase) throws Exception {
        String selectQuery = null;

        Connection con = null;
        DatabaseMetaData metaData = null;
        PreparedStatement ps = null;
        ResultSet rs = null;

        try {
            con = this.getConnection();
            con.setAutoCommit(false);
            if (wherePhrase == null) selectQuery = "select * from tab_portal_qna order by board_id, priority desc";
            else selectQuery = "select * from tab_portal_qna " + wherePhrase;
            ps = con.prepareStatement(selectQuery, ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
            rs = ps.executeQuery();

            con.commit();
            con.setAutoCommit(true);

            Vector vector = new Vector();

            if (bundleIndex != 0 && postBundleSize != 00) rs.absolute(bundleIndex * postBundleSize);
            for (int i=0; i<postBundleSize; i++) {
                if (rs.next()) {
                    CompleteQNAVo qnaVo = new CompleteQNAVo();
					int boardId = rs.getInt("board_id");
					if (rs.wasNull()) qnaVo.setBoardId(null);
					else qnaVo.setBoardId(new Integer(boardId));
	
					int parentPostId = rs.getInt("parent_post_id");
					if (rs.wasNull()) qnaVo.setParentPostId(null);
					else qnaVo.setParentPostId(new Integer(parentPostId));
					
					int postId = rs.getInt("post_id");
					if (rs.wasNull()) qnaVo.setPostId(null);
					else qnaVo.setPostId(new Integer(postId));
	
					String authorId = rs.getString("author_id");
					if (authorId != null) qnaVo.setAuthorId(authorId);
	
					String title = rs.getString("title");
					if (title != null) qnaVo.setTitle(title);
	
					String content = rs.getString("content");
					if (content != null) qnaVo.setContent(content);
	
					String ipAddr = rs.getString("ip_addr");
					if (ipAddr != null) qnaVo.setIpAddr(ipAddr);
	
					int views = rs.getInt("views");
					if (rs.wasNull()) qnaVo.setViews(null);
					else qnaVo.setViews(new Integer(views));
	
					Boolean htmlFlag = new Boolean(rs.getBoolean("html_flag"));
					if (htmlFlag != null) qnaVo.setHtmlFlag(htmlFlag);
	
					Boolean maskFlag = new Boolean(rs.getBoolean("mask_flag"));
					if (maskFlag != null) qnaVo.setMaskFlag(maskFlag);
					
					int threadDepth = rs.getInt("thread_depth");
					if (rs.wasNull()) qnaVo.setThreadDepth(null);
					else qnaVo.setThreadDepth(new Integer(threadDepth));
	
					int priority = rs.getInt("priority");
					if (rs.wasNull()) qnaVo.setPriority(null);
					else qnaVo.setPriority(new Integer(priority));
	
					java.sql.Date postedDate = rs.getDate("posted_date");
					if (postedDate != null) qnaVo.setPostedDate(postedDate);
					
					java.sql.Date updatedDate = rs.getDate("updated_date");
					if (updatedDate != null) qnaVo.setUpdatedDate(updatedDate);
	
					vector.add(qnaVo);
                }
            }
            return (CompleteQNAVo[]) vector.toArray(new CompleteQNAVo[vector.size()]);
        } catch (SQLException ex) {
            System.out.println("query: "+selectQuery);
            ex.printStackTrace();
            throw ex;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (rs != null) rs.close();
            if (ps != null) ps.close();
            if (con != null) con.close();
        }
    }
}
