/* Generated by Together */

package com.sds.portal.post.facade;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.CreateException;
import javax.sql.*;
import javax.naming.*;
import java.util.*;
import javax.ejb.*;

import com.sds.portal.post.*;
import com.sds.portal.post.entity.QNAEntityLocal;
import com.sds.portal.post.entity.QNAEntityLocalHome;
import com.sds.portal.post.dao.QNADao;
import com.sds.portal.post.vo.CompleteQNAVo;
import com.sds.common.util.Locator;


/**
 * @ejbHome <{com.sds.portal.post.facade.QNAFacadeHome}>
 * @ejbRemote <{com.sds.portal.post.facade.QNAFacade}>
 * @ejbLocal <{QNAFacadeLocal}>
 * @ejbLocalHome <{QNAFacadeLocalHome}>
 * @ejbTransactionAttribute Required 
 * @undefined
 * @displayName
 * @ejbBeanIdentifier QNAFacade
 */
public class QNAFacadeBean implements SessionBean, QNAInterface {
    private SessionContext ctx;

    private QNADao qnaDao = null;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private QNAEntityLocal qnaEntityLocal;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private QNAEntityLocalHome qnaEntityLocalHome;

    /** @link dependency */
    /*# CompleteQNAVo lnkCompleteQNAVo; */

    public void setSessionContext(SessionContext context) throws RemoteException, EJBException {
        ctx = context;
    }

    public void ejbActivate() throws EJBException {
    }

    public void ejbPassivate() throws EJBException {
    }

    public void ejbRemove() throws EJBException {
    }

    public void ejbCreate() throws CreateException, EJBException {
        try {
			DataSource ds = (DataSource) Locator.getInstance().lookup("java:comp/env/jdbc/dataSourceRef");
			if (ds == null) throw new Exception("datasource is null");
			qnaDao = new QNADao(ds);

			qnaEntityLocalHome = (QNAEntityLocalHome) Locator.getInstance().getLocalHome("java:comp/env/ejb/qnaEntityLocalRef");
		} catch (NamingException ex) {
			ex.printStackTrace();
			throw new EJBException();
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException();
		}
	}

    public CompleteQNAVo getCompleteQNAVo(Integer postId) throws EJBException {
        try {
			try {
	            qnaEntityLocal = qnaEntityLocalHome.findByPrimaryKey(postId);
            } catch (FinderException ex) {
                return null;
            }
            CompleteQNAVo qnaVo = new CompleteQNAVo();
            qnaVo.setPostId(qnaEntityLocal.getPostId());

            qnaVo.setParentPostId(qnaEntityLocal.getParentPostId());
            qnaVo.setBoardId(qnaEntityLocal.getBoardId());
            qnaVo.setAuthorId(qnaEntityLocal.getAuthorId());
            qnaVo.setTitle(qnaEntityLocal.getTitle());
            qnaVo.setContent(qnaEntityLocal.getContent());
            qnaVo.setIpAddr(qnaEntityLocal.getIpAddr());
            qnaVo.setHtmlFlag(qnaEntityLocal.getHtmlFlag());
            qnaVo.setMaskFlag(qnaEntityLocal.getMaskFlag());
            qnaVo.setThreadDepth(qnaEntityLocal.getThreadDepth());
            qnaVo.setPriority(qnaEntityLocal.getPriority());
            qnaVo.setPostedDate(qnaEntityLocal.getPostedDate());
            qnaVo.setUpdatedDate(qnaEntityLocal.getUpdatedDate());
            qnaVo.setViews(qnaEntityLocal.getViews());
            return qnaVo;
        } catch (Exception ex) {
            throw new EJBException();
        }

    }

	public CompleteQNAVo[] list(int bundleIndex, int postBundleSize, String wherePhrase) throws EJBException {
        return this.getCompleteQNAVoArray(bundleIndex, postBundleSize, wherePhrase);
    }

    public CompleteQNAVo[] getCompleteQNAVoArray(int bundleIndex, int postBundleSize, String wherePhrase) throws EJBException {
        try {
            return qnaDao.getCompleteQNAVoArray(bundleIndex, postBundleSize, wherePhrase);
        } catch (Exception ex) {
            throw new EJBException();
        }
    }

    public int getNumberOfPosts(String wherePhrase) throws EJBException {
        try {
            return qnaDao.getNumberOfQNAs(wherePhrase);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public int getNumberOfPosts() throws EJBException {
        try {
            return qnaDao.getNumberOfQNAs();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public CompleteQNAVo read(Integer postId) throws EJBException {
        try {
            try {
            	qnaEntityLocal = qnaEntityLocalHome.findByPrimaryKey(postId);
            } catch (Exception ex) {
                return null;
            }
            Integer views = qnaEntityLocal.getViews();
            qnaEntityLocal.setViews(new Integer(views.intValue() + 1));

            return this.getCompleteQNAVo(postId);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public Integer post(CompleteQNAVo qnaVo) throws EJBException {
        try {
            Integer parentPostId = qnaVo.getParentPostId();
            // post
            if (parentPostId == null) {
				qnaVo.setPriority(qnaDao.getNextPriority(qnaVo.getBoardId()));
                qnaVo.setThreadDepth(new Integer(0));
            // reply
            } else {
                qnaEntityLocal = qnaEntityLocalHome.findByPrimaryKey(parentPostId);
                qnaVo.setThreadDepth(new Integer(qnaEntityLocal.getThreadDepth().intValue() + 1));

                Integer lastChildPostId = qnaDao.getLastChildPostId(parentPostId);
                // has sibling
                if (lastChildPostId != null){
                    qnaEntityLocal = qnaEntityLocalHome.findByPrimaryKey(lastChildPostId);
					Integer lastChildPostPriority = qnaEntityLocal.getPriority();
                    qnaDao.raisePriority(lastChildPostId);
                    qnaVo.setPriority(lastChildPostPriority);
                // a only son
                } else {
                    Integer parentPostPriority = qnaEntityLocal.getPriority();
                    qnaDao.raisePriority(parentPostId);
                    qnaVo.setPriority(parentPostPriority);
                }
            }

            Integer postId = new Integer(qnaDao.getNextSequence());

            // manual primary key generation
            qnaVo.setPostId(postId);
            // auto primary key generation
            ;


            qnaVo.setPostedDate(new java.sql.Date((Calendar.getInstance().getTime()).getTime()));
            qnaEntityLocalHome.create(qnaVo);
			return postId;

        } catch (NamingException ex) {
            ex.printStackTrace();
            throw new EJBException();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public Integer reply(CompleteQNAVo qnaVo) throws EJBException {
        return this.post(qnaVo);
    }

    public void update(CompleteQNAVo qnaVo) throws EJBException {
        try {
            Integer postId = qnaVo.getPostId();
            qnaEntityLocal = qnaEntityLocalHome.findByPrimaryKey(postId);
            qnaVo.setUpdatedDate(new java.sql.Date((Calendar.getInstance().getTime()).getTime()));
            qnaEntityLocal.update(qnaVo);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public void delete(Integer postId) throws EJBException {
        try {
			if (qnaDao.hasChild(postId)) throw new HasChildException("Cannot delete post which is referenced by others");
            qnaEntityLocal = qnaEntityLocalHome.findByPrimaryKey(postId);
            qnaEntityLocal.remove();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }
}
