/* Generated by Together */

package com.sds.portal.post.facade;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.CreateException;
import javax.naming.*;
import java.util.*;

import com.sds.portal.post.QNAFileInterface;
import com.sds.portal.post.vo.*;
import com.sds.portal.post.facade.*;
import com.sds.portal.file.vo.*;
import com.sds.portal.file.facade.*;
import com.sds.common.util.*;

/**
 * @ejbHome <{com.sds.portal.post.facade.QNAFileFacadeHome}>
 * @ejbRemote <{com.sds.portal.post.facade.QNAFileFacade}>
 * @ejbLocal <{com.sds.portal.post.facade.QNAFileFacadeLocal}>
 * @ejbLocalHome <{com.sds.portal.post.facade.QNAFileFacadeLocalHome}> 
 * @undefined
 * @displayName
 * @ejbBeanIdentifier QNAFileFacade
 */
public class QNAFileFacadeBean implements SessionBean, QNAFileInterface {
    private SessionContext ctx;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private QNAFacade qnaFacadeRemote;
    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileFacade fileFacadeRemote;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    private FileMapFacade fileMapFacadeRemote;

    public void setSessionContext(SessionContext context) throws RemoteException, EJBException {
        ctx = context;
    }

    public void ejbActivate() throws EJBException {
    }

    public void ejbPassivate() throws EJBException {
    }

    public void ejbRemove() throws EJBException {
    }

    public void ejbCreate() throws CreateException, EJBException {
        try {
            Locator locator = Locator.getInstance();

            qnaFacadeRemote = ((QNAFacadeHome) locator.getRemoteHome("java:comp/env/ejb/qnaFacadeRemoteRef")).create() ;
            fileFacadeRemote = ((FileFacadeHome) locator.getRemoteHome("java:comp/env/ejb/fileFacadeRemoteRef")).create();
            fileMapFacadeRemote = ((FileMapFacadeHome) locator.getRemoteHome("java:comp/env/ejb/fileMapFacadeRemoteRef")).create();
		} catch (NamingException ex) {
			ex.printStackTrace();
			throw new EJBException();
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException();
		}
    }

    public CompleteQNAFileVo[] getCompleteQNAFileVoArray(int bundleIndex, int postBundleSize, String wherePhrase) throws EJBException {
        try {
            CompleteQNAVo[] qnaVoArray = null;
            qnaVoArray = qnaFacadeRemote.getCompleteQNAVoArray(bundleIndex, postBundleSize, wherePhrase);
            Integer postId = null;
            Vector vector = new Vector();
            for (int i=0; i<qnaVoArray.length; i++) {
                postId = qnaVoArray[i].getPostId();
                vector.add(this.getCompleteQNAFileVo(postId));
            }
            return (CompleteQNAFileVo[]) vector.toArray(new CompleteQNAFileVo[vector.size()]);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public int getNumberOfPosts(String wherePhrase) throws EJBException {
        try {
            return qnaFacadeRemote.getNumberOfPosts(wherePhrase);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public CompleteQNAFileVo getCompleteQNAFileVo(Integer postId) throws EJBException {
        try {
            CompleteQNAFileVo qnaFileVo = new CompleteQNAFileVo();
            CompleteQNAVo qnaVo = null;
            FileVo[] fileVoArray = null;

            qnaVo = qnaFacadeRemote.getCompleteQNAVo(postId);
            String wherePhrase = " where post_id = '"+postId+"'";
            FileMapVo[] fileMapVoArray = fileMapFacadeRemote.getFileMapVoArray(wherePhrase);

            Integer fileId = null;
            FileVo fileVo = null;
            Vector vector = new Vector();
            for (int i=0; i<fileMapVoArray.length; i++) {
                fileId = fileMapVoArray[i].getFileId();
                try {
					fileVo = fileFacadeRemote.getFileVo(fileId);
					if (fileVo != null) vector.add(fileVo);
                } catch (Exception ex) {
                    // file map link collapsed
                }
            }
            fileVoArray = (FileVo[]) vector.toArray(new FileVo[vector.size()]);

            qnaFileVo.setQNAVo(qnaVo);
            qnaFileVo.setFileVoArray(fileVoArray);

			return qnaFileVo;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public void reply(CompleteQNAFileVo qnaFileVo) throws EJBException {
		try {
			CompleteQNAVo qnaVo = qnaFileVo.getQNAVo();
			FileVo[] fileVoArray = qnaFileVo.getFileVoArray();
            
            Integer boardId = qnaVo.getBoardId();
            Integer postId = qnaFacadeRemote.reply(qnaVo);
            Integer[] fileIdArray = fileFacadeRemote.upload(fileVoArray);

            FileMapVo fileMapVo = null;
            for (int i=0; i<fileIdArray.length; i++) {
                fileMapVo = new FileMapVo();
                fileMapVo.setBoardId(boardId);
                fileMapVo.setPostId(postId);
                fileMapVo.setFileId(fileIdArray[i]);
            }
            fileMapFacadeRemote.map(fileMapVo);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public int getNumberOfPosts() throws EJBException {
        try {
            return qnaFacadeRemote.getNumberOfPosts();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public CompleteQNAFileVo read(Integer postId) throws EJBException {
        try {
			return this.getCompleteQNAFileVo(postId);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

	public CompleteQNAFileVo[] list(int bundleIndex, int postBundleSize, String wherePhrase) throws EJBException {
		try {
            Vector qnaFileVoVector = new Vector();
            CompleteQNAVo[] qnaVoArray = qnaFacadeRemote.list(bundleIndex, postBundleSize, wherePhrase);

            Integer postId = null;
            Integer fileId = null;
            FileMapVo[] fileMapVoArray = null;
            CompleteQNAFileVo qnaFileVo = null;
            FileVo fileVo = null;

            for (int i=0; i<qnaVoArray.length; i++) {
                qnaFileVo.setQNAVo(qnaVoArray[i]);
                postId = qnaVoArray[i].getPostId();
                String tmpWherePhrase = "post_id = '"+postId+"'";
                fileMapVoArray = fileMapFacadeRemote.getFileMapVoArray(tmpWherePhrase);
                Vector fileVoVector = new Vector();
                for (int j=0; j<fileMapVoArray.length; j++) {
                    fileId = fileMapVoArray[i].getFileId();
                    try {
	                    fileVo = fileFacadeRemote.getFileVo(fileId);
    	                if (fileVo != null) fileVoVector.add(fileVo);
                    } catch (Exception ex) {
                        // file map link collapsed
                    }
                }
                qnaFileVo.setFileVoArray((FileVo[]) fileVoVector.toArray(new FileVo[fileVoVector.size()]));
                qnaFileVoVector.add(qnaFileVo);
            }
            return (CompleteQNAFileVo[]) qnaFileVoVector.toArray(new CompleteQNAFileVo[qnaFileVoVector.size()]);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public void post(CompleteQNAFileVo qnaFileVo) throws EJBException {
        try {
            CompleteQNAVo qnaVo = qnaFileVo.getQNAVo();
			FileVo[] fileVoArray = qnaFileVo.getFileVoArray();
            Integer boardId = qnaVo.getBoardId();
            Integer postId = qnaFacadeRemote.post(qnaVo);

            if (fileVoArray != null && fileVoArray.length > 0) {
				Integer[] fileIdArray = fileFacadeRemote.upload(fileVoArray);
				FileMapVo fileMapVo = null;
				for (int i=0; i<fileIdArray.length; i++) {
					fileMapVo = new FileMapVo();
					fileMapVo.setBoardId(boardId);
					fileMapVo.setPostId(postId);
					fileMapVo.setFileId(fileIdArray[i]);
                    fileMapFacadeRemote.map(fileMapVo);
				}
            }

        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public void deleteQNA(Integer postId) throws EJBException {
        try {
            qnaFacadeRemote.delete(postId);

            String wherePhrase = " where post_id = '"+postId+"'";
            FileMapVo[] fileMapVoArray = fileMapFacadeRemote.getFileMapVoArray(wherePhrase);

            Integer fileId = null;
            Integer mapId = null;
            for (int i=0; i<fileMapVoArray.length; i++) {
                fileId = fileMapVoArray[i].getFileId();
                mapId = fileMapVoArray[i].getMapId();
                fileFacadeRemote.delete(fileId);
                fileMapFacadeRemote.delete(mapId);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public void update(CompleteQNAFileVo qnaFileVo) throws EJBException {
        try {
            CompleteQNAVo qnaVo = qnaFileVo.getQNAVo();
			FileVo[] fileVoArray = qnaFileVo.getFileVoArray();

            Integer boardId = qnaVo.getBoardId();
            qnaFacadeRemote.update(qnaVo);
            Integer postId = qnaVo.getPostId();
            Integer[] fileIdArray = fileFacadeRemote.upload(fileVoArray);

            // delete unselected file map info
			String wherePhrase = " where post_id = '"+postId+"'";
            FileMapVo[] fileMapVoArray = fileMapFacadeRemote.getFileMapVoArray(wherePhrase);
            for (int i=0; i<fileMapVoArray.length; i++) {
                fileMapFacadeRemote.delete(fileMapVoArray[i].getMapId());
            }

            // assign selected file map info
            FileMapVo fileMapVo = null;
            for (int j=0; j<fileVoArray.length; j++) {
                fileMapVo = new FileMapVo();
                fileMapVo.setBoardId(boardId);
                fileMapVo.setPostId(postId);
                fileMapVo.setFileId(fileIdArray[j]);
                fileMapFacadeRemote.map(fileMapVo);
            }

        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }

    public void deleteFile(Integer fileId) throws EJBException {
        try {
            fileFacadeRemote.delete(fileId);
            String wherePhrase = " where file_id = '"+fileId+"'";
            FileMapVo[] fileMapVoArray = fileMapFacadeRemote.getFileMapVoArray(wherePhrase);
            for (int i=0; i<fileMapVoArray.length; i++)
	            fileMapFacadeRemote.delete(fileMapVoArray[i].getMapId());
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException();
        }
    }
}
