<!--
Title: qna_upload_sample
Description: qna upload ui control template
Create on:
Modified on:
Author: codelabor@codelabor.org
Browsers: IE5+ and NS6+

Made by codelabor http://codelabor.org
May be used and changed freely as long as this msg is intact
-->
<%@ page 
contentType="text/html; charset=euc-kr"
import="
java.util.*,
com.sds.common.util.Locator,
com.sds.portal.post.vo.*,
com.sds.portal.post.command.ListQNACmd
"
%>

<%
Locator locator = Locator.getInstance();

// list data
CompleteQNAVo[] qnaVoArray = (CompleteQNAVo[]) request.getAttribute(ListQNACmd.PARAM_QNA_VO_ARRAY);

// page info
ListPageInfoVo listPageInfoVo = (ListPageInfoVo) request.getAttribute(ListQNACmd.PARAM_LIST_PAGE_INFO_VO);

// search condition
HashMap searchCondition = listPageInfoVo.getSearchCondition();
String searchKeyword = (String) searchCondition.get(ListQNACmd.PARAM_SEARCH_KEYWORD);
Boolean tmpSearchTargetAuthorId = (Boolean) searchCondition.get(ListQNACmd.PARAM_SEARCH_TARGET_AUTHOR_ID);
Boolean tmpSearchTargetTitle = (Boolean) searchCondition.get(ListQNACmd.PARAM_SEARCH_TARGET_TITLE);
Boolean tmpSearchTargetContent = (Boolean) searchCondition.get(ListQNACmd.PARAM_SEARCH_TARGET_CONTENT);
boolean searchTargetAuthorId = false;
boolean searchTargetTitle = false;
boolean searchTargetContent = false;
if (tmpSearchTargetAuthorId != null) searchTargetAuthorId = tmpSearchTargetAuthorId.booleanValue();
if (tmpSearchTargetTitle != null) searchTargetTitle = tmpSearchTargetTitle.booleanValue();
if (tmpSearchTargetContent != null) searchTargetContent = tmpSearchTargetContent.booleanValue();

%>

<html>
    <head>
        <meta http-equiv="Content-Type" title="text/html;charset=euc-kr">
        <link type="text/css" rel="stylesheet" href="./css/theme/default/table.css">        
        <script language="javascript" src="./js/servlet_utility.js"></script>
        <script language="javascript">
            <!--
            var servletUtility = new ServletUtility();
            servletUtility.setContextPath('\<%= request.getContextPath() %>');
            //-->
        </script>        
        <script language="javascript" src="./js/post_qna.js"></script>
        <script language="javascript" src="./js/read_qna.js"></script>
        <script language="javascript" src="./js/delete_qna.js"></script>
        <script language="javascript" src="./js/list_qna.js"></script>
        <style type="text/css">
            <!--

            .no {
                width: 50px;
                text-align: right;
            }

            .boardId {
                width: 50px;
                text-align: right;
            }
            
            .postId {
                width: 50px;
                text-align: right;
            }
            
            .qnaTitle {
                width: 300px;
                text-align: left;
            }

            .views {
                width: 20px;
                text-align: right;
            }
            
            .action {
                text-align: center;
            }

            .pageIndex {
                width: 20px;
            }
            
            
            //-->
        </style>

    </head>
    <body>
        <div id="titleDivision">
            <h1>Posted QNA List</h1>
        </div>
        
        <hr>

        <div id="searchDivision">
            <form id="listQNAForm">
                <% if (searchTargetAuthorId) { %>
                    <input type="checkbox" name="<%= ListQNACmd.PARAM_SEARCH_TARGET_AUTHOR_ID %>" checked>author
                <% } else { %>
                    <input type="checkbox" name="<%= ListQNACmd.PARAM_SEARCH_TARGET_AUTHOR_ID %>">author
                <% } %>
                <% if (searchTargetTitle) { %>
                    <input type="checkbox" name="<%= ListQNACmd.PARAM_SEARCH_TARGET_TITLE %>" checked>title
                <% } else { %>
                    <input type="checkbox" name="<%= ListQNACmd.PARAM_SEARCH_TARGET_TITLE %>">title
                <% } %>
                <% if (searchTargetContent) { %>
                    <input type="checkbox" name="<%= ListQNACmd.PARAM_SEARCH_TARGET_CONTENT %>" checked>content
                <% } else { %>
                    <input type="checkbox" name="<%= ListQNACmd.PARAM_SEARCH_TARGET_CONTENT %>">content
                <% } %>
                <input type="text" name="<%= ListQNACmd.PARAM_SEARCH_KEYWORD %>" value="<%= searchKeyword %>">
                <input type="button" value="search" onClick="javascript: listQNA(0, this.form.id)">
            </form>
        </div>


        <div id="listDivision">
            <%
            out.println("[hits: "+listPageInfoVo.getNumberOfHits()+" / total: "+listPageInfoVo.getNumberOfPosts()+"]");
            %>
            <table>
                <thead>
                <tr>
                    <th>no</th><th>boardId</th><th>postId</th><th>title</th><th>authorId</th><th>views</th><th>action</th>
                </tr>
                </thead>
                <tbody>
            <%
           
            Integer[] postNumberArray = listPageInfoVo.getPostNumberArray();
            if (qnaVoArray == null) {
            } else {
                for (int i=0; i<qnaVoArray.length; i++) {
                    // for debugging uncomment below
                    //out.print(qnaVoArray[i].toString());
                    out.println("<tr>");
                    
                    out.print("<td class='no'>");
                    out.print(postNumberArray[i]);
                    out.print("</td>");

                    out.print("<td class='boardId'>");
                    out.print(qnaVoArray[i].getBoardId());
                    out.print("</td>");
                    
                    out.print("<td class='postId'>");
                    out.print(qnaVoArray[i].getPostId());
                    out.print("</td>");
                    
                    out.print("<td class='qnaTitle'>");
                    for (int j=0; j<qnaVoArray[i].getThreadDepth().intValue(); j++) out.println("&nbsp;&nbsp;"); 
                    out.print(qnaVoArray[i].getTitle());
                    out.print("</td>");
                    
                    out.print("<td class='authorId'>");
                    out.print(qnaVoArray[i].getAuthorId());
                    out.print("</td>");
                    
                    out.print("<td class='views'>");
                    out.print(qnaVoArray[i].getViews());
                    out.print("</td>");

                    out.print("<td>");
                    out.print("<input type='button' value='read' onClick='javascript: readQNA("+qnaVoArray[i].getPostId()+")'>");
                    out.print("<input type='button' value='delete' onClick='javascript: deleteQNA("+qnaVoArray[i].getPostId()+")'>");
                    out.print("</td>");


                    out.println("</tr>");
                }
            }
            %>
                </tbody>
            </table>
        </div>
        
        <div id="indexDivision">
        <span class='pageIndex'><a href="javascript: listQNA(<%= listPageInfoVo.getFirstPageIndex() %>, 'listQNAForm')">[first]</a></span>
        <span class='pageIndex'><a href="javascript: listQNA(<%= listPageInfoVo.getPreviousPageIndex() %>, 'listQNAForm')">[prev]</a></span>
        <%
        /*
        out.println("<span class='pageIndex'><a href='javascript: listQNA('listQNAForm', "+listPageInfoVo.getFirstPageIndex()+")'>[first]</a></span>");
        out.println("<span class='pageIndex'><a href='javascript: listQNA('listQNAForm', "+listPageInfoVo.getPreviousBundlePageIndex()+")'>[prev]</a></span>");
        */
        
        Integer[] pageIndexArray = listPageInfoVo.getPageIndexArray();
        for (int j=0; j<pageIndexArray.length; j++) {
        %> 
            <span class='pageIndex'><a href="javascript: listQNA(<%= pageIndexArray[j] %>, 'listQNAForm')">[<%= (pageIndexArray[j].intValue() + 1) %>]</a></span>
       <%
          //out.print("<span class='pageIndex'><a href='javascript: listQNA('listQNAForm', "+pageIndexArray[j]+")'>["+ (pageIndexArray[j].intValue() + 1) +"]</a></span>");
        }
        
        /*
        out.println("<span class='pageIndex'><a href='javascript: listQNA('listQNAForm', "+listPageInfoVo.getNextBundlePageIndex()+")'>[next]</a></span>");
        out.println("<span class='pageIndex'><a href='javascript: listQNA('listQNAForm', "+listPageInfoVo.getLastPageIndex()+")'>[last]</a></span>");
        */
        %>
        <span class='pageIndex'><a href="javascript: listQNA(<%= listPageInfoVo.getNextPageIndex() %>, 'listQNAForm')">[next]</a></span>
        <span class='pageIndex'><a href="javascript: listQNA(<%= listPageInfoVo.getLastPageIndex() %>, 'listQNAForm')">[last]</a></span>
        </div>
        
        <hr>
        
        <div id="buttonDivison">
            <input type="button" value="post" onClick="javascript: prePostQNA()">
        </div>
    </body>
</html>


